#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector<pair<int,int>> niz(n);
    for(int i = 0;i < n;i++) cin >> niz[i].first >> niz[i].second;

    int mxx = -1,mxy = -1;
    int mnx = 1000001,mny = 1000001;
    long long MXN = 1000000007;
    for(int i = 0;i < n;i++){
        mnx = min(mnx,niz[i].first);
        mny = min(mny,niz[i].second);
        mxx = max(mxx,niz[i].first);
        mxy = max(mxy,niz[i].second);
        long long ans1 = 0,ans2 = 0,ans3 = 0,ans4 = 0;
        for(int j = 0;j < i;j++){
            long long x1,x2,y1,y2;
            x1 = abs(niz[j].first%MXN - mnx%MXN)%MXN;
            y1 = abs(niz[j].second%MXN - mny%MXN)%MXN;
            x2 = abs(niz[j].first%MXN - mxx%MXN)%MXN;
            y2 = abs(niz[j].second%MXN - mxy%MXN)%MXN;
            ans1 = (ans1%MXN + (x1%MXN * y1%MXN)%MXN)%MXN;
            ans2 = (ans2%MXN + (x1%MXN * y2%MXN)%MXN)%MXN;
            ans3 = (ans3%MXN + (x2%MXN * y1%MXN)%MXN)%MXN;
            ans4 = (ans4%MXN + (x2%MXN * y2%MXN)%MXN)%MXN;
        }
        cout << max(ans1,max(ans2,max(ans3,ans4))) << "\n";
    }

    return 0;
}